<template>
  <section class="grid-etape">
    <section class="mt-blue-pale"></section>
    <section class="grid-etape-item columns is-hidden-mobile">
      <div
        v-for="(avancement, index) in participer.avancements"
        :key="index"
        class="column"
        :class="cssEtape(avancement)"
        :title="title(avancement)"
      >
        <p>
          {{ avancement.etape.ordre
          }}<mark v-if="isStop(avancement)"><b-icon icon="alert-circle" custom-class="stop-size"/></mark>
        </p>
      </div>
    </section>
    <section class="grid-etape-item ligne2 columns">
      <h4
        v-for="(avancement, index) in participer.avancements"
        :key="index"
        class="column"
        :class="cssEtape(avancement)"
        :title="title(avancement)"
      >
        {{ libelle(avancement) }}
        <small> {{ description(avancement) }}</small>
        <time>{{ date(avancement) }}</time>
      </h4>
    </section>
  </section>
</template>

<script>
import { DateTime } from 'luxon';

export default {
  name: 'MtListEtapesEmploye',
  props: {
    participer: {
      type: Object,
      default: () => ({}),
    },
  },
  methods: {
    cssEtape(avancement) {
      if (this.isStop(avancement)) {
        return 'est-realiser last-etape is-stop';
      }
      if (this.isRealiser(avancement) && !this.isLastEtape(avancement)) {
        return 'est-realiser';
      }
      if (this.isRealiser(avancement) && this.isLastEtape(avancement)) {
        return 'est-realiser last-etape';
      }
      return '';
    },
    isRealiser(avancement) {
      return !!avancement.estRealiser;
    },
    isLastEtape(avancement) {
      return avancement.id === this.participer.dernierAvancement.id;
    },
    date(avancement) {
      if (!avancement.dateValidation) {
        return '';
      }
      const date = DateTime.fromISO(avancement.dateValidation);
      return date.toFormat('dd/MM/yyyy');
    },
    isStop(avancement) {
      return avancement.choix && avancement.choix.typeEtatChoix.code === 'stop';
    },
    title(avancement) {
      const { validateur } = avancement;
      if (validateur && validateur.nom !== null) {
        return `Étape validée par ${validateur.nom} ${validateur.prenom}`;
      }
      return '';
    },
    libelle(avancement) {
      if (this.isStop(avancement)) {
        return avancement.choix.statut.nomSingulier;
      }
      return avancement.etape.nom;
    },
    description(avancement) {
      if (this.isStop(avancement)) {
        return '';
      }
      return avancement.etape.description;
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

.grid-etape {
  --page-size: #{$mt-container-small-width};
  display: grid;
  grid-template-columns: auto minmax(auto, var(--page-size)) auto;

  .grid-etape-item {
    grid-column: 2;
    text-align: center;
    margin-bottom: -1px;

    &.ligne2 {
      grid-row: 2;
    }
    div {
      display: flex;
      justify-content: center;
      cursor: default;
      position: relative;
      border-bottom: 1px solid transparent;

      &.est-realiser + .est-realiser:not(.last-etape) {
        border-bottom-color: $periwinkle;
      }

      &.is-stop mark {
        position: absolute;
        color: $puce-indisponible;
        display: flex;
        align-items: center;
        justify-content: center;
        margin-left: 2rem;
        margin-bottom: 0.75rem;
        background-color: transparent;
      }

      &.est-realiser:not(.last-etape):before {
        content: '';
        position: absolute;
        width: 50%;
        height: 1px;
        background-color: $periwinkle;
        bottom: -1px;
        right: 0;
      }
      &.est-realiser + .est-realiser.last-etape:before {
        content: '';
        position: absolute;
        width: 50%;
        height: 1px;
        background-color: $periwinkle;
        bottom: -1px;
        left: 0;
        right: unset;
      }
    }
    .est-realiser p {
      color: $periwinkle-blue;

      &:after {
        background-color: $periwinkle-blue;
      }
    }
    .last-etape p {
      background-color: $primary;
      box-shadow: 0 1px 2px 0 #b8b8b8;
      color: $white;

      &:after {
        background-color: $primary;
      }
    }
    p {
      display: flex;
      flex-direction: column;
      height: 1.6875rem;
      width: 1.6875rem;
      border-radius: 50%;
      align-items: center;
      justify-content: center;
      margin: 0.5rem;
      font-size: 0.875rem;
      color: #999999;

      background-color: transparent;
      box-shadow: 0 1px 2px 0 transparent;

      transition-property: background-color, color, box-shadow;
      transition-duration: 0.3s;

      &:after {
        content: '';
        --size: 0.375rem;
        width: var(--size);
        height: var(--size);
        background-color: #c7c7c7;
        border-radius: 50%;
        bottom: calc(-1 * var(--size) / 2);
        position: absolute;

        transition-property: background-color;
        transition-duration: 0.3s;
      }
    }
    h4 {
      color: #999999;
      font-size: 0.9375rem;
      padding: 0.75rem;

      transition-property: color;
      transition-duration: 0.3s;

      cursor: default;

      &.est-realiser {
        color: $periwinkle;
      }
      &.est-realiser.last-etape {
        color: $primary;
        font-weight: bold;
      }

      small {
        display: block;
        font-size: 0.625rem;
      }
    }
  }
  .mt-blue-pale {
    grid-row: 2;
    grid-column: 1 / -1;
    border-top: 1px solid #e8edf8;
  }
}
/deep/ .stop-size::before {
  font-size: 1.2rem;
}
</style>
